/// @cond EO_CXX_EO_IMPL

inline ::eldbus::model_signal::_c_constructor eldbus::model_signal::constructor(Eldbus_Proxy * proxy_, const Eldbus_Introspection_Signal * signal_)
{
   return _c_constructor(proxy_, signal_);
}

inline ::eo_cxx::eldbus::model_signal::operator ::eldbus::model_signal() const
{
   return *static_cast<::eldbus::model_signal const*>(static_cast<void const*>(this));
}

inline ::eo_cxx::eldbus::model_signal::operator ::eldbus::model_signal&()
{
   return *static_cast<::eldbus::model_signal*>(static_cast<void*>(this));
}

inline ::eo_cxx::eldbus::model_signal::operator ::eldbus::model_signal const&() const
{
   return *static_cast<::eldbus::model_signal const*>(static_cast<void const*>(this));
}

namespace efl { namespace eo { namespace detail {

template<>
struct operations< ::eldbus::model_signal >
{
   template <typename T>
   struct type
         : virtual operations< ::eldbus::model_arguments >::template type<T>
   {
   };
};


template<>
struct operation_description_class_size< ::eldbus::model_signal >
{
   static constexpr int value = 
#if defined(MODEL_SIGNAL_PROTECTED) && defined(MODEL_SIGNAL_BETA)
      0
#elif defined(MODEL_SIGNAL_PROTECTED)
      0
#elif defined(MODEL_SIGNAL_BETA)
      0
#else
      0
#endif
      + operation_description_class_size<::eldbus::model_arguments >::value;
};

template <typename T>
int initialize_operation_description(::efl::eo::detail::tag<::eldbus::model_signal>
                                 , Eo_Op_Description* ops)
{
   int i = 0;
   (void)i;
   (void)ops;
   initialize_operation_description<T>(::efl::eo::detail::tag<::eldbus::model_arguments>(), &ops[operation_description_class_size< ::eldbus::model_signal >::value]);
   return 0;
}
inline Eo_Class const* get_eo_class(tag<::eldbus::model_signal>)
{
   return (ELDBUS_MODEL_SIGNAL_CLASS);
}

} } }

/// @endcond

